"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = nodeChildrenToScrollState;
function nodeChildrenToScrollState(_ref) {
  var children = _ref.children,
      scrollTop = _ref.scrollTop;

  var list = [];

  // used to increment children view heights
  var start = 0;

  // Fix: default props
  // let { theshold } = this.props
  var theshold = 0.5;

  // TODO: experiment a map
  for (var i = 0; i < children.length; i++) {
    var _children$i = children[i],
        offsetHeight = _children$i.offsetHeight,
        attributes = _children$i.attributes;

    // interpreting native values

    var viewHeight = offsetHeight;
    var end = start + viewHeight;

    // current location values
    var location = start - scrollTop;
    var locationFloat = location / offsetHeight;
    var locationFloatRemainer = locationFloat <= -1 ? 1 : locationFloat >= 1 ? 1 : Math.abs(locationFloat % 1);

    /* Used for creating navigations and  to links to
    *  <Link to="Home" />
    */
    var name = attributes.name ? attributes.name.value : null;

    // Conditionals
    // FIX: use exact values
    var onView = locationFloat <= theshold && locationFloat >= -theshold;
    var onFrame = location === scrollTop;
    // TODO: review active
    // TODO: addfunction to run on activate()
    var active = onView;

    list.push({ name: name, location: location, locationFloat: locationFloat, locationFloatRemainer: locationFloatRemainer, start: start, end: end, viewHeight: viewHeight, onView: onView, active: active, onFrame: onFrame });

    // increament based on stacked item's height
    start += offsetHeight + 1;
  }

  return { children: list };
}